<?php
namespace PME\Controllers\RestricoesContratuais;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

class RestricaoProdutoController {
    
  protected $entityManager;
  protected $environment;
  protected $connection;
  
  public function __construct($entityManager, $connection, $environment) {
  	$this->entityManager = $entityManager;
  	$this->environment = $environment;
  	$this->connection = $connection;
  }
  
  public function returnCodRestProd(DTO\Request $request, DTO\Response $response) {
    $sql = "SELECT MAX(NRRESTPRODPAE) CODIGO FROM RESTPRODPAE";

    $codigo = $this->entityManager->getConnection()->fetchAll($sql);
    $response->addDataSet(new DataSet("codigo", $codigo));
  }
  
  private function getMaxItRestProd() {
    $sql = "SELECT MAX(NRITRESTPRODPAE) NRITRESTPRODPAE FROM ITRESTPRODPAE";

    $result = $this->entityManager->getConnection()->fetchAssoc($sql);
    return $result;
  }
  
  public function getMaxItRestProdGrup() {
    $sql = "SELECT MAX(NRITRESTPRODGRPRPAE) NRITRESTPRODGRPRPAE FROM ITRESTPRODGRPRPAE";

    $result = $this->entityManager->getConnection()->fetchAssoc($sql);
    return $result;
  }
  
  public function saveItRestProd(DTO\Request $request, DTO\Response $response) {
      try {			
    			$params = $request->getParameters()["editedRows"];
    			
    			foreach ($params as $param) {
    			  $nrIt = $this->getMaxItRestProd();
    				
    				// Insere produto restrito
    				$sql = "INSERT INTO ITRESTPRODPAE (NRITRESTPRODPAE, NRRESTPRODPAE, CDPRODUTO, NRORG)
    				        VALUES (:NRITRESTPRODPAE, :NRRESTPRODPAE, :CDPRODUTO, :NRORG)";
                    
            $paramsIn = array(
                'NRITRESTPRODPAE' => $nrIt['NRITRESTPRODPAE'] + 1,
                'NRRESTPRODPAE' => $param['NRRESTPRODPAE'],
                'CDPRODUTO' => $param['CDPRODUTO'],
                'NRORG' => $this->environment->getNrOrg()
            );
            
            $this->entityManager->getConnection()->prepare($sql)->execute($paramsIn);
    			}
      } catch (\Exception $e) {
	    	$response->setError(new Error($e->getMessage(), 500));
	    }
  }
  
  public function saveItRestProdGrup(DTO\Request $request, DTO\Response $response) {
    try {			
			$params = $request->getParameters()["editedRows"];
			
			foreach ($params as $param) {
	      $nrIt = $this->getMaxItRestProdGrup();
				
				// Insere produto na frequencia de grupo de prato
				$sql = "INSERT INTO ITRESTPRODGRPRPAE (NRITRESTPRODGRPRPAE, NRRESTPRODPAE, NRGRUPOPRATOPAE, CDPRODUTO)
				        VALUES (:NRITRESTPRODGRPRPAE, :NRRESTPRODPAE, :NRGRUPOPRATOPAE, :CDPRODUTO)";
                
        $paramsIn = array(
            'NRITRESTPRODGRPRPAE' => $nrIt['NRITRESTPRODGRPRPAE'] + 1,
            'NRRESTPRODPAE' => $param['NRRESTPRODPAE'],
            'NRGRUPOPRATOPAE' => $param['NRGRUPOPRATOPAE'],
            'CDPRODUTO' => $param['CDPRODUTO']
        );
        
        $this->entityManager->getConnection()->prepare($sql)->execute($paramsIn);
			}
    } catch (\Exception $e) {
	    $response->setError(new Error($e->getMessage(), 500));
    }
  }
}